#if 0 /* autogenerated by uutil_db.pl ... */
 set -eu;
 WARN="-Wall -Wno-long-long -Wstrict-prototypes -pedantic"
 WARN="$WARN -Wcast-align -Wpointer-arith " # -Wfloat-equal #-Werror
 WARN="$WARN -W -Wwrite-strings -Wcast-qual -Wshadow" # -Wconversion
 case ${1:-} in '') set x -O2 ### set x -ggdb;
	shift ;; esac;
 set -x; ${CC:-gcc} $WARN "$@" -c "$0"
 exit $?
 */
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include "uutil.h"

void die(const char * format, ...)
{
    va_list ap;

    va_start(ap, format);
    vwarn(format, ap);
    va_end(ap);
    exit(1);
}

void vwarn(const char * format, va_list ap)
{
    int error = errno; /* XXX is this too late ? */

    vfprintf(stderr, format, ap);
    if (format[strlen(format) - 1] == ':')
	fprintf(stderr, " %s\n", strerror(error));
    else
	fputs("\n", stderr);
    fflush(stderr); /* needed sometimes... */
}

int move_fd(int oldfd, int newfd)
{
    int rv;
    if (oldfd == newfd)
	return 0;
    rv = dup2(oldfd, newfd);
    close(oldfd);
    return rv;
}

void vfdprintf1k(int fd, const char * format, va_list ap)
{
    char buf[1024];
    size_t len = vsnprintf(buf, sizeof buf, format, ap);
    if (len > sizeof buf)
	len = sizeof buf;
    (void)write(fd, buf, len);
}

void fdprintf1k(int fd, const char * format, ...)
{
    va_list ap;
    va_start(ap, format);
    vfdprintf1k(fd, format, ap);
    va_end(ap);
}

